<script lang="ts">
  import { keycloak } from '../../../stores.js';
  import { updateKanbanComment, type KanbanComment, deleteKanbanComment } from '../../../models/Kanban.js';
  import type { TeamUser } from '@models/Team.js';
  import UserBadge from '@components/UserBadge.svelte';
  import EditMarkdown from '@components/Markdown/EditMarkdown.svelte';
  import Markdown from '@components/Markdown/Markdown.svelte';
  import moment from 'moment';
  import { getNotificationsContext } from 'svelte-notifications';
  import Confirm from '@components/Confirm/Confirm.svelte';
  import { Button } from '@sveltestrap/sveltestrap';

  const { addNotification } = getNotificationsContext();

  export let teammates: TeamUser[];
  export let comment: KanbanComment;

  let author: TeamUser | undefined = undefined;

  $: author = teammates.find((t) => t.id === comment.author_id);

  let myUserId: string | undefined;
  $: myUserId = $keycloak?.tokenParsed?.sub;
</script>

<div class="border border-secondary rounded bg-dark p-2">
  <div>
    <div class="d-flex flex-row flex-wrap align-middle" style="line-height: 40px">
      <div>
        {#if author}
          <UserBadge userId={comment.author_id} firstName={author.first_name} lastName={author.last_name} small />
        {:else}
          {comment.author_id}
        {/if}
      </div>
      <div class="flex-grow-1" />

      {#if comment.created !== comment.modified}
        <div class="text-muted">
          Edited {moment(comment.modified).fromNow()}
        </div>
      {:else}
        <div class="text-muted">
          {moment(comment.created).fromNow()}
        </div>
      {/if}
      {#if comment.author_id === myUserId}
        <div class="ml-2">
          <Confirm let:confirm={confirmDelete}>
            <Button
              on:click={() =>
                confirmDelete(() => {
                  deleteKanbanComment(comment.id);
                })}
              color="danger"
              class="mx-2"
            >
              Delete
            </Button>
          </Confirm>
        </div>
      {/if}
    </div>
  </div>
  <hr style="border-color: white" />
  <div class="p-1">
    {#if comment.author_id === myUserId}
      <EditMarkdown
        text={comment.content}
        minLength={1}
        maxLength={600}
        multiline
        on:save={(event) => {
          updateKanbanComment(comment.id, event.detail);
          addNotification({
            text: `Comment Edited`,
            position: 'bottom-right',
            removeAfter: 2500,
            type: 'success',
          });
        }}
      />
    {:else}
      <div class="text-wrap text-break">
        <Markdown source={comment.content} />
      </div>
    {/if}
  </div>
</div>
